


layout(1)                USER COMMANDS                  layout(1)



NAME
     layout
          - layout a network / graph in 2D.


SYNOPSIS
     layout [options]


DESCRIPTION
     Layout creates a 2D network graph from a list  of  nodenames
     and  connections  between the nodes. Nodes are drawn as rec-
     tangular boxes with the name of the node inside the box.
     Connections between nodes are drawn  as  lines  between  the
     boxes.
     Layout produces its output after a number of  iterations  in
     which  the  nodes get their position in the graph. It checks
     the size of the boxes, and uses these to prevent overlapping
     of  nodes. layout also makes sure that the boxes stay within
     the window.

     Layout reads from standard  input,  which  must  consist  of
     lines with 3 or 6 fields:
     The 6 field line has the following syntax:
          id nodename x_coord y_coord width height.
     Where id is the networkidentifier of the node,  nodename  is
     the  name  of  the node, x_coord is the initial x_coordinate
     for this node, y_coord is the initial y_coordinate for  this
     node,  width  is  the initial width of the box and height is
     the initial height of the box.
     The 3 field line has the following syntax:
          interface= nodename1 nodename2.
     This line specifies  a  connection  between  the  two  nodes
     nodename1 and nodename2.

     Layout produces output which consists of lines with 3  or  6
     fields.  The  6 field line gives us the networkidentifier of
     the node, the name of the node, the final x_coordinate,  the
     final y_coordinate, the (possibly) adjusted width of the box
     and the (possibly) adjusted height of the box. The  3  field
     line is just a copy of the 3_field_line input.


OPTIONS
     -H s    Highlight a node and all of its connections to other
             nodes.   This  is only sensible when using the -p or
             -P option. The characterstring s defines the name of
             the node.

     -P [file]
             Produce colorpostscript-output. The filename for the
             postscript   can   be  given.  Default  filename  is



Monet               Last change: Release 0.10                   1






layout(1)                USER COMMANDS                  layout(1)



             /tmp/psfile.  This gives a possibility  to  see  how
             the  network will look like after a number of itera-
             tions. See also -p. Only one of -P/-p  is  possible.
             When  you  edit the postscriptfile it is possible to
             get an a3-format.  Default is no colorpostscript.

     -a      Do not let the program determine what the  sizes  of
             the  window  will be. See also -h and -w. Default is
             autosizing of the window.

     -c s    Use characterstring s  for  the  connection-typename
             between the linked nodes. Default is interface=.

     -f f    Use factor f for determination of the force_vectors.
             This  factor  is  used  in  the determination of the
             forces between the nodes. When you want  a  stronger
             interaction  between  them, you have to enlarge this
             factor. When you want to  reduce    the  interaction
             you  have to enter a factor between 0 and 1. Default
             is 1.

     -h x    Define the height of the 2D window to  be  used  for
             the  layout.  This  must  be large enough to fit all
             nodes into it (and move them around).  See  also  -a
             and -w. Default is 1000.

     -i x    Define the number  of  iterations.  If  you  do  not
             specify  the  number  of iterations it will be 10. A
             large number of  iterations  (e.g.  100)  is  recom-
             mended.

     -l      Do not print the linkstructure, containing  informa-
             tion  about  which  node is connected to which node.
             Default is print the linkstructure.

     -n      Do not print the nodestructure, containing  informa-
             tion about the nodename, the new coordinates and the
             sizes of the box. Default is  print  the  nodestruc-
             ture.

     -p [file]
             Produce  postscript-output.  The  postscriptfilename
             can  be given. Default filename is /tmp/psfile. This
             gives a possibility to see how the network will look
             like after a number of iterations. See also -P. Only
             one  of  -p/-P  is  possible.  When  you  edit   the
             postscriptfile  it  is possible to get an a3-format.
             Default is no postscript.

     -r      Put the nodes at random places on the window.  Nodes
             with  more  connections to other nodes get closer to
             the center of the 2D window. Default is off. However



Monet               Last change: Release 0.10                   2






layout(1)                USER COMMANDS                  layout(1)



             when a node has a zero x-coordinate it gets a random
             x_coordinate and when it has a zero y-coordinate  it
             gets a random y_coordinate.

     -s      Do not check maximum boxsizes. Use this option  only
             if there are nodes with large sizes. The size of the
             box depends primarily on the length of the  name  of
             the  node. When a node has more connections the size
             is somewhat enlarged. Default is sizecheck.

     -w x    Define the width of the 2D window to be used for the
             layout. See also -a and -h. Default is 1000.


FILES
     /tmp/psfile      The (default)file with postscript output of
          the program.


EXAMPLES
          cat links.database | layout -w 1500 -h 1000 -p
     In this example we use a windowwidth  of  1500  and  a  win-
     dowheight  of  1000  to  layout the nodes in the file called
     "links.database". We also want the results to  be  saved  in
     postscript.

          cat nodefile | layout -r -i 150 -p.
     We place the nodes in file "nodefile" at random places in  a
     2D  window  (nodes with more links closer to the center). We
     determine 150 times what the interactions  are  between  all
     nodes. Finally we produce postscriptoutput.

     Possible input consists of the following lines:
     con= ip.host:hef-router.nikhef.nl ip.network:192.16.183.0
     con= ip.host:hef-router.nikhef.nl ip.network:192.16.192.0
     con= ip.host:cwi-gw.cwi.nl ip.network:192.16.183.0
     con= ip.host:cwi-gw.cwi.nl ip.network:192.16.192.0
     ip.host:hef-router.nikhef.nl  hef-router.nikhef.nl  368  432
     130 13
     ip.network:192.16.183.0 192.16.183.0 330 394 92 12
     ip.network:192.16.192.0 192.16.192.0 210 464 368 19
     ip.host:cwi-gw.cwi.nl cwi-gw.cwi.nl 258 362 88 13


DIAGNOSTICS
     When the number of nodes increase the time used  for  layout
     goes up.


IMPLEMENTATION
     Linked nodes attract, while non-linked nodes repel. The for-
     cevector  between  two nodes depents on the distance between



Monet               Last change: Release 0.10                   3






layout(1)                USER COMMANDS                  layout(1)



     them.
     Only nodes with more than one link to other nodes with  more
     than one link are used for the place_determination.
     Nodes with only two connections to  other  nodes  with  more
     links are placed somewhat in between these two nodes.
     Nodes with only one link to  a  node  with  more  links  are
     placed close to the node they are connected with.
     Nodes without connections to other nodes are placed  on  the
     bottompart  of  the window (after the iterations of the pro-
     gram).
     Nodes with one connection to another node with only this one
     connection  are placed on the upperpart of the window (after
     the iterartions of the program).
     After finishing the iterations  there  is  an  overlap_check
     (and  fix).   There  is  also a resizing of the window and a
     reduction of all large gaps between nodes.


LIMITATIONS
     At this moment the number of  different  structures  in  the
     program make it hard not to go nuts. It must be rewritten so
     that we use the links counted for a node and  not  the  dif-
     ferent structures with nodes with 0, 1 etc. links.
     It is very hard to see where the nodes with more  links  are
     placed,  due  to  the  amount of procedures used, concerning
     placing of nodes.


BUGS
     When the windowsizes are too small there are likely problems
     for placing all nodes into this window.
     At  this  moment  the  gap-reduction  needed  for  an  extra
     compression (the -a switch) (lower/upper part and left/right
     part of the window) fails. But I'm working on it.
     Has been known to go into an infinite loop.

AUTHOR
     Gerard Leurs
     NIKHEF-H, Amsterdam, Netherlands


SEE ALSO
     monet(1N)












Monet               Last change: Release 0.10                   4



